//-------+---------+---------+---------+---------+---------+---------+--------=
//
// File:	bobutil.h								Author:		Bob Harris
//
//----------
//
// Interface definitions for C support module
//
//----------

#ifndef bobutil_H
#define bobutil_H

//----------
//
// globally available data in bobutil.c
//
//----------

#ifndef __bobutil_owner
extern const signed char  nuc_to_bits[256];
extern const char*        bits_to_nuc;
extern const char*        bits_to_aa;
#endif

//----------
//
// prototypes for routines in bobutil.c
//
//----------

void          parse_seq_name     (char* h,
                                  char** name, char** longName, char* chr,
                                  unsigned long* first, unsigned long* last,
                                  char* strand);
void          parse_seq_name2    (char* h, int commatize,
                                  char** name, char** longName, char* chr,
                                  unsigned long* first, unsigned long* last,
                                  char* strand, char** extra);
char*         comma_string       (unsigned long v);
char*         number_string      (unsigned long v);
char*         skip_whitespace    (const char* s);
char*         skip_blackspace    (const char* s);
char*         string_to_upper    (char* s);
int           string_to_int      (char* s, int* val);
int           strcmplax          (const char* s1, const char* s2);
int           strncmplax         (const char* s1, const char* s2, size_t n);
char*         new_string_f       (const char* fmt, ...);
char*         chomp_gets         (char* s, int n, FILE* stream);
char*         chomp_string       (char* s);
int           digits_of          (long v);
int           unsigned_digits_of (unsigned long v);
unsigned long next_lex_combo     (unsigned long m, unsigned long n,
                                  unsigned long v);
char          str_to_chromosome  (char* s);
char*         chromosome_to_str  (char chr);
char          nuc3_to_aa         (unsigned char* nuc);
char          nuc3_to_bits       (unsigned char* nuc);
int           is_wild_match      (const char* s, const char* pattern);
int           bit_count          (unsigned long bits);

int      greatest_common_divisor (int a, int b);
int      least_common_multiple   (int a, int b);

#endif // bobutil_H
